Index: /main/trunk/gli/classes/dictionary_gu.properties
===================================================================
--- /main/trunk/gli/classes/dictionary_gu.properties	(revision 31713)
+++ /main/trunk/gli/classes/dictionary_gu.properties	(revision 31714)
@@ -1025,4 +1025,6 @@
 Mirroring.DownloadJob.Pause:àª¥à«àª­à«
 Mirroring.DownloadJob.Pause_Tooltip:àª àª¡àªŸàªàªšàª²à«àª¡àªšà« àª¥à«àª­àªŸàªµà«
+Mirroring.DownloadJob.Stop:àª¬àªàª§ àªàª°à«
+Mirroring.DownloadJob.Stop_Tooltip:àª àª¡àªŸàªàªšàª²à«àª¡àªšà« àªªà«àª°àªàª¿àª¯àªŸ àª°à«àªà«
 Mirroring.DownloadJob.Resume:àª«àª°à« àª¶àª°à« àªàª°à«
 Mirroring.DownloadJob.Resume_Tooltip:àª àª¡àªŸàªàªšàª²à«àª¡àªšà« àª«àª°à« àª¶àª°à« àªàª°à«
Index: /main/trunk/gli/help/gu/help.xml
===================================================================
--- /main/trunk/gli/help/gu/help.xml	(revision 31713)
+++ /main/trunk/gli/help/gu/help.xml	(revision 31714)
@@ -112,8 +112,27 @@
 àª®à«àª àªžàª®àª¯ àª²àªŸàªà« àª¶àªà« àªà«. àªà«àª¯àªŸàª°à« "àª€àª®àªŸàª® àª®à«àªàªŸàª¡à«àªàªŸ' àªµàª¿àªšà«àª¡à« àªà«àª²à«àª²à« àª¹à«àª¯ àª€à«àª¯àªŸàª°à« àª€àª®à« àª²àªŸàªàª¬à«àª°à«àª°à«àª¯àªš àªàªšà«àªàª°àª«à«àª¶àªšà« àª
 àªµàª¿àª°àª€ àªàªªàª¯à«àª àªàª°à« àª¶àªà« àªà«.</Text>
+<Text id="101">àªàª¯àªŸàª°à« àª€à« àªà«àª¬àª àªµàª¿àªžà«àª€àªŸàª° àªªàªŸàª®à« àª€à«àª¯àªŸàª°à« àªà«àª²àª®à«àªž àª«àª¿àª²à«àªàª°àªšàªŸ àªàªªàª¯à«àª àªŠà«àªµàªŸàª°àªŸ "àª¬àª§àªŸ àª àª®à«àªàªŸàª¡à«àªàªŸ" àªà«àª¬àª²àªšà« àª«àª¿àª²à«àªàª° àªàª°à« àª¶àªà« àªà«. àªà«àªµàªŸ àªšàªµàªŸ àª«àª¿àª²à«àªàª° àªàª®à«àª°àªµàªŸàª®àªŸàª àªàªµà« àª€à« àªžàªàªà«àªà«àª®àªŸàª àª®àªŸàª€à«àª° àª àª àª°à« àª€à«àªšà« àª®à«àª àªàª°àª¶à« àªà« àª¬àªŸàªà« àª°àª¹à«àª€àªŸ àª¹à«àª¯.àª«àª¿àª²à«àªàª°  àªžà«àª àªàª°àªµàªŸ, àªžà«àª§àªŸàª°àªµàªŸ àª
+àª¥àªµàªŸ àª°àªŠàª¬àªŸàª€àª² àªàª°àªµàªŸ àªà«àª²àª®àªšà« àªàªªàª°àªšàªŸ àª­àªŸàªà« àªàªªà«àª²  "àªàª³àª£à«" àªà«àªµàªŸ àªŠà«àªàªŸàª€àªŸ àªàªàªà«àªš àªªàª° àªà«àª²àª¿àª àªàª°à«. àª€àª®àªŸàª°à« àª«àª¿àª²à«àªàª° àªªàªžàªàªŠ àªàª°àªµà«àª àªªàª¡àª¶à«. àªàªàªµàªàª€ àª«àª¿àª²à«àªàª° àªžà«àª àª¥àª àªàªŸàª¯ àª€àª°àª€ àª àªà«àª²àª® àª¹à«àª¡àª° àªàª²àª° àª¬àªŠàª²àª¶à«.  </Text>
+<Text id="102">àª«àª¿àª²à«àªàª° àªªà«àª°à«àª®à«àªªà«àªàª®àªŸàª "àªžàª¿àª®à«àªªàª²" àª
+àªšà« "àªàª¡àªµàªŸàªšà«àªž" àªà«àª¬ àª¹à«àª¯ àªà«. àªžàª¿àª®à«àªªàª² àªµàª°à«àªàªš àªà«àª²àª®àªšà« àª«àª¿àª²à«àªàª° àªàª°à« àªà« àªà«àª¥à« àª€à« àª àª àª°à« àª¬àª€àªŸàªµà« àªà« àªà« àªà«àª®àªŸàª àªà«àª àªà«àªà«àªàªž àª®à«àªàªŸàª¡à«àªàªŸ àªµà«àª²à«àª¯à« àª¹à«àª¯ ("*" àª€àª®àªŸàª® àªµà«àª²à«àª¯à« àª®à«àª àªàª°à« àªà«). àªªà«àª²-àª¡àªŸàªàªš àª¯àªŸàªŠà«àª®àªŸàªàª¥à« àª€àª®à« àª®à«àªàªŸàª¡à«àªàªŸ àªµà«àª²à«àª¯à« àªªàªžàªàªŠ àªàª°à« àª¶àªà« àªà«. àªàª¡àªµàªŸàªšà«àªž àªµàª°à«àªàªš àªµàª¿àªµàª¿àª§ àª®à«àªàª¿àªàª àªàªªàª°à«àª¶àªšà«àªž àªŠàª°à«àª¶àªŸàªµà« àªà«: àªà«àª® àªà« àª¶àª°à«àªàª€ àªàªšàªŸàª¥à« àª àª¥àªµà« àªà«àªàª, àª àªàªšà« àªžàªŸàª¥à« àª¹à«àªµà«àª àªà«àªàª àªšàª¹àª¿, àªµàª°à«àª£àªŸàªšà«àªà«àª°àª®à« àªàªŸ àª€à« àªàªšàªŸ àªàª°àª€àªŸ àªàªàªŸ àª
+àª¥àªµàªŸ àªžàª°àªàªŸ àª¹à«àªµàªŸ àªà«àªàª. àªà«àªàªªàª£ àªžà«àªà«àª°à«àªàª àª¹à«àª¯ àªà« àªµà«àª²à«àª¯à« àª®à«àª àª¥àªµàªŸàªšà« àªà« àª€à«àª®àªŸàª àªžà«àª§àªŸàª°àªŸ àªµàª§àªŸàª°àªŸ àªàª°à« àª¶àªàªŸàª¯, àª
+àªšà« àªà« àª®à«àªàª¿àªàª àªà«àªž àªàªšà«àªžà«àªšà«àªžàª¿àªà«àªµ (àªšàªŸàªšàªŸ àª
+àª¥àªµàªŸ àª®à«àªàªŸ àª®à«àª³àªŸàªà«àª·àª°à« àª®àªŸàªàª¥à« àªà«àªàªªàª£ àª®à«àª³àªŸàªà«àª·àª°à«àªšà« àªàªªàª¯à«àªàªšà« àªžà«àªµà«àªà«àª€àª¿) àª¹à«àª¯ àª€à« àªªàª£ àª€àª®à« àª€à«àªšà« àªªàªžàªàªŠ àªàª°à« àª¶àªà« àªà«. àª
+àªàª€àª®àªŸàª, àª¬à«àªà« àª®à«àªàª¿àªàª àª¶àª°àª€ àª€àª®à« àªšàªà«àªà« àªàª°à« àª¶àªà« àªà« àªà« àªà«àªšà« àªàªªàª¯à«àª àª°à«àªšà«àª àªµà«àª²à«àª¯à« àªšàªà«àªà« àªàª°àªµàªŸ àª®àªŸàªà« ('àª
+àªšà«' àªªàªžàªàªŠ àªàª°à«àªšà«) àª
+àª¥àªµàªŸ àªµà«àªàª²à«àªªàª¿àª àªµà«àª²à«àª¯à« ('àª
+àª¥àªµàªŸ' àªªàªžàªàªŠ àªàª°à«àªšà«) àªªàªžàªàªŠ àªàª°àªµàªŸ àªàª°à« àª¶àªà« àªà«. àª àªàªà«àª¯àªŸàªšà« àªšà«àªà« àªàª àª¬à«àªà«àª· àªà« àªà«àªšàªŸàª¥à« àªžà«àª°à«àª àªà«àª°àª® àª¬àªŠàª²à« àª¶àªàªŸàª¯ àªà« (àªàª¡àª€àªŸ àªà«àª°àª® àªà« àªàª€àª°àª€àªŸ àªà«àª°àª®àª®àªŸàª). àªàª àªµàªàª€ àª àªà«àª°àª¿àª¯àªŸ àªªà«àª°à«àª£ àª¥àª¯àªŸ àª¬àªŸàªŠ àªà«àª²àª®àª®àªŸàª àªšàªµà«àª àª«àª¿àª²à«àªàª°àªšà« àªàªªàª¯à«àª àªàª°àªµàªŸ àª®àªŸàªà«  'àª«àª¿àª²à«àªàª° àªžà«àª àªàª°à«" àªªàª° àªà«àª²àª¿àª àªàª°à«. àª¹àªŸàª² àª
+àªžà«àª€àª¿àª€à«àªµàª®àªŸàª àª°àª¹à«àª² àª«àª¿àª²à«àªàª°àªšà« àªŠà«àª° àªàª°àªµàªŸ "àª«àª¿àª²à«àªàª° àªžàªŸàª« àªàª°à«" àªªàª° àªà«àª²àª¿àª àªàª°à«. àª¯àªŸàªŠ àª°àªŸàªà«, àªàªàªµàªàª€ àª«àª¿àª²à«àªàª° àªžàªŸàª« àªàª°à«àª¯àªŸ àª¬àªŸàªŠ àª«àª¿àª²à«àªàª°àªšà« àªµà«àª²à«àª¯à« àª®à«àª³ àªžà«àª¥àª¿àª€àª¿àª®àªŸàª àªªàª°àª€ àª®à«àª³àªµà« àª¶àªàªŸàª¯ àªà«. </Text>
+<Text id="103">àªŠàªŸ:àª€ "àª¬àª§àªŸàª àª®à«àªàªŸàª¡à«àªàªŸ" àªà«àª¬àª² àªžà«àª°à«àª àªàª°àªµàªŸ, àªà«àª²àª® àªªàªžàªàªŠ àªàª°à«, àª¡àª¿àª«à«àª²à«àª àªžà«àªàª¿àªàª (àªžàª¿àª®à«àªªàª² àª«àª¿àª²à«àªàª° àªàªŸàª²à« "*"), àª
+àªšà« àªàª¡àª€à« àªà«àª°àª® àª
+àª¥àªµàªŸ àªàª€àª°àª€à« àªà«àª°àª® àªªàªžàªàªŠ àªàª°à«.</Text>
 </Section>
 <Section name="importingpreviouslyassignedmetadata">
 <Title>
-</Title>
+<Text id="104">àª
+àªàªŸàª àªšàªà«àªà« àªàª°à«àª² àª®à«àªàªŸàª¡à«àªàªŸàªšà« àªàª®à«àªªà«àª°à«àª àªàª°à«.</Text>
+</Title>
+<Text id="105">àª
+àªàªŸàª àªšàªà«àªà« àªàª°à«àª² àª®à«àªàªŸàª¡à«àªàªŸàªšà« àªàª®à«àªªà«àª°à«àª àªà«àªµà« àª°à«àª€à« àªàª°àªµàªŸ àª€à«àªšà«àª àªµàª°à«àª£àªš àª àªµàª¿àª­àªŸàªàª®àªŸàª àªŠàª°à«àª¶àªŸàªµàªµàªŸàª®àªŸàª àªàªµà«àª¯à«àª àªà«: àªžàªàªà«àª°àª¹àª®àªŸàª àªªà«àª°àª²à«àªà« àªàª®à«àª°àªµàªŸàª®àªŸàª àªàªµà« àª€à« àªªàª¹à«àª²àªŸ àªªà«àª°àª²à«àª àªžàªŸàª¥à« àª®à«àªàªŸàª¡à«àªàªŸ àªšàªà«àªà« àªàª°àªµàªŸàª®àªŸàª àªàªµà« àªà«.</Text>
 </Section>
 </Section>
Index: /main/trunk/gli/help/gu/help_index.xml
===================================================================
--- /main/trunk/gli/help/gu/help_index.xml	(revision 31713)
+++ /main/trunk/gli/help/gu/help_index.xml	(revision 31714)
@@ -1,2 +1,2 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<Document><Section name="introduction"><Title/><Section name="ofmiceandmenus"><Title/></Section><Section name="howtoavoidthisdocument"><Title/></Section></Section><Section name="startingoff"><Title/><Section name="creatingacollection"><Title/></Section><Section name="savingacollection"><Title/></Section><Section name="openingacollection"><Title/></Section><Section name="deletingcollections"><Title/></Section></Section><Section name="downloadingfiles"><Title/><Section name="themirrorview"><Title/></Section></Section><Section name="collectingfiles"><Title/><Section name="thegatherview"><Title/></Section><Section name="creatingshortcuts"><Title/></Section><Section name="creatingfolders"><Title/></Section><Section name="addingfiles"><Title/></Section><Section name="replacingfiles"><Title/></Section><Section name="removingfiles"><Title/></Section><Section name="explodingfiles"><Title/></Section><Section name="filteringthetree"><Title/></Section></Section><Section name="enrichingacollection"><Title/><Section name="theenrichview"><Title/></Section><Section name="selectingmetadatasets"><Title/></Section><Section name="appendingmetadata"><Title/></Section><Section name="addingpreviouslydefinedmetadata"><Title/></Section><Section name="updatingmetadata"><Title/></Section><Section name="reviewingmetadata"><Title/></Section><Section name="importingpreviouslyassignedmetadata"><Title/></Section></Section><Section name="designingacollection"><Title/><Section name="thedesignview"><Title/></Section><Section name="plugins"><Title/></Section><Section name="searchindexes"><Title/><Section name="searchindexoptions"><Title/></Section></Section><Section name="partitionindexes"><Title/><Section name="definefilters"><Title/></Section><Section name="assignpartitions"><Title/></Section><Section name="assignlanguages"><Title/></Section></Section><Section name="classifiers"><Title/></Section></Section><Section name="producingthecollection"><Title/><Section name="thecreateview"><Title/></Section><Section name="builderrors"><Title/></Section><Section name="expertbuilding"><Title/></Section><Section name="scheduledbuilding"><Title/></Section></Section><Section name="formattingacollection"><Title/><Section name="theformatview"><Title/></Section><Section name="generalsettings"><Title/></Section><Section name="searchmetadatasettings"><Title/></Section><Section name="formatstatements"><Title/></Section><Section name="translatetext"><Title/></Section><Section name="xcollectionsearching"><Title/></Section><Section name="collectionspecificmacros"><Title/></Section><Section name="depositormetadatasettings"><Title/></Section></Section><Section name="miscellaneous"><Title/><Section name="preferences"><Title/></Section><Section name="fileassociations"><Title/></Section><Section name="exporting"><Title/></Section><Section name="exportingcollections"><Title/></Section></Section></Document>
+<Document><Section name="introduction"><Title>àªªà«àª°àªžà«àª€àªŸàªµàªšàªŸ</Title><Section name="ofmiceandmenus"><Title/></Section><Section name="howtoavoidthisdocument"><Title/></Section></Section><Section name="startingoff"><Title/><Section name="creatingacollection"><Title/></Section><Section name="savingacollection"><Title/></Section><Section name="openingacollection"><Title/></Section><Section name="deletingcollections"><Title/></Section></Section><Section name="downloadingfiles"><Title/><Section name="themirrorview"><Title/></Section></Section><Section name="collectingfiles"><Title/><Section name="thegatherview"><Title/></Section><Section name="creatingshortcuts"><Title/></Section><Section name="creatingfolders"><Title/></Section><Section name="addingfiles"><Title/></Section><Section name="replacingfiles"><Title/></Section><Section name="removingfiles"><Title/></Section><Section name="explodingfiles"><Title/></Section><Section name="filteringthetree"><Title/></Section></Section><Section name="enrichingacollection"><Title/><Section name="theenrichview"><Title/></Section><Section name="selectingmetadatasets"><Title/></Section><Section name="appendingmetadata"><Title/></Section><Section name="addingpreviouslydefinedmetadata"><Title/></Section><Section name="updatingmetadata"><Title/></Section><Section name="reviewingmetadata"><Title/></Section><Section name="importingpreviouslyassignedmetadata"><Title/></Section></Section><Section name="designingacollection"><Title/><Section name="thedesignview"><Title/></Section><Section name="plugins"><Title/></Section><Section name="searchindexes"><Title/><Section name="searchindexoptions"><Title/></Section></Section><Section name="partitionindexes"><Title/><Section name="definefilters"><Title/></Section><Section name="assignpartitions"><Title/></Section><Section name="assignlanguages"><Title/></Section></Section><Section name="classifiers"><Title/></Section></Section><Section name="producingthecollection"><Title/><Section name="thecreateview"><Title/></Section><Section name="builderrors"><Title/></Section><Section name="expertbuilding"><Title/></Section><Section name="scheduledbuilding"><Title/></Section></Section><Section name="formattingacollection"><Title/><Section name="theformatview"><Title/></Section><Section name="generalsettings"><Title/></Section><Section name="searchmetadatasettings"><Title/></Section><Section name="formatstatements"><Title/></Section><Section name="translatetext"><Title/></Section><Section name="xcollectionsearching"><Title/></Section><Section name="collectionspecificmacros"><Title/></Section><Section name="depositormetadatasettings"><Title/></Section></Section><Section name="miscellaneous"><Title/><Section name="preferences"><Title/></Section><Section name="fileassociations"><Title/></Section><Section name="exporting"><Title/></Section><Section name="exportingcollections"><Title/></Section></Section></Document>
Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_gu.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_gu.properties	(revision 31713)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_default_gu.properties	(revision 31714)
@@ -43,5 +43,9 @@
 home.librarian_interface:àªà«àª°àªàª¥àªªàªŸàª² àªàªšà«àªàª°àª«à«àª¶
 home.select_a_collection:àªžàªàªà«àª°àª¹àªšà« àªªàªžàªàªŠ àªàª°à«
+home.select_a_group:àªà«àª°à«àªª àªªàªžàªàªŠ àªàª°à«
+home.select_a_collection_or_group:àªžàªàªà«àª°àª¹ àª
+àª¥àªµàªŸ àªà«àª°à«àªª àªªàªžàªàªŠ àªàª°à«
 home.no_collections:àª àª²àªŸàªàª¬à«àª°à«àª°à«àª®àªŸàª àªàªàªªàª£ àª®àªŸàªšà«àª¯ àªžàªàªà«àª°àª¹à« àªšàª¥à«
+home.no_collections_group:àª àªà«àª°à«àªªàª®àªŸàª àªà«àª àª®àªŸàªšà«àª¯ àªžàªàªà«àª°àª¹à« àªšàª¥à«
 #***** logged in menu
 menu.account_settings:àªàªàªŸàªàªšà«àª àªžà«àªàª¿àªàªà«àªž
@@ -146,4 +150,5 @@
 doc.map_nearby_docs:àª
 àª¹à«àª àªªà«àª°àª²à«àªà«àªšà« àªšàªà«àª àªŠàª°à«àª¶àªŸàªµà«
+
 maps.scrolllabel:àªžà«àª¥àª³à«àª¥à« àªžà«àªà«àª°à«àª² àªàª°à«
 
@@ -153,4 +158,15 @@
 àªàªŸàªàªšàªŸ àªªà«àª°àª²à«àª àªªàª° àªàªµàªŸ àª®àªŸàªà« àª€àª®àªŸàª°àªŸ àª¬à«àª°àªŸàªàªàª°àªšà«àª 'àªªàªŸàªàª³' àª¬àªàªšàªšà« àªàªªàª¯à«àª àªàª°à«.
 external.go_forward:àªàªàª³ àªµàª§à«
+
+#########################################################
+#  User Comments section (available on a document page) #
+#########################################################
+
+usercomments.username:àª¯à«àªàª°àªšàªŸàª®
+usercomments.add:àªà«àª®à«àªšà«àª àªàª®à«àª°à«
+usercomments.submit:àªà«àª®à«àªšà«àª àª®à«àªàª²à«
+usercomments.submitted:àªà«àª®à«àªšà«àª àª®à«àªàª²à«
+usercomments.isempty:àªà«àª®à«àªšà«àª àªàªŸàª²à« àª¹àª€à«.
+usercomments.heading:àªà«àª®à«àªšà«àªà«àªž
 
 #####################