Index: main/trunk/gli/src/org/greenstone/gatherer/download/DownloadJob.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/download/DownloadJob.java	(revision 31720)
+++ main/trunk/gli/src/org/greenstone/gatherer/download/DownloadJob.java	(revision 31721)
@@ -212,8 +212,6 @@
 	    previous_state = getState();
 	    if (getState() == RUNNING) {
-		//setState(STOPPED);
-		stopDownload(); // cancels any running SafeProcess
+		stopDownload(); // cancels any running SafeProcess, will set the current state to STOPPED when the time is right
 	    } else {
-		//previous_state = getState();
 		setState(RUNNING);
 		mummy.resumeThread();
@@ -225,6 +223,5 @@
 	    if(getState() == RUNNING) {
 		previous_state = getState();
-		//setState(STOPPED); // do we need to do anything else to stop this? YES, we do:
-		stopDownload(); // cancels any running SafeProcess
+		stopDownload(); // cancels any running SafeProcess, will set the current state to STOPPED when the time is right
 	    }
 	    mummy.deleteDownloadJob(this);
@@ -731,13 +728,4 @@
 
 	SafeProcess.log("@@@@ DONE callDownload()");
-	
-	/*
-	// Regardless of whether state==STOPPED or ends up being COMPLETE, the process is at an end now.
-	// Notify the DownloadScrollPane which is waiting on this job to complete that we are ready 
-	synchronized(this) {
-	    System.err.println("**************** Notifying download scrollpane");
-	    this.notify();
-	}
-	*/	
 
 	// refresh the workspace tree
@@ -758,18 +746,4 @@
 	    boolean hadToSendInterrupt = prcs.cancelRunningProcess(); // returns false if it was already terminating/terminated, true if interrupt sent
 
-
-	    /*
-	      // if process terminating naturally but waiting for process' worker threads to join(),
-	      // shall we just remove the progress bar display for this download?
-		  // If so, do this section in place of the 2 calls to progress.enableCancelJob(boolean) below
-	    if(!hadToSendInterrupt && SwingUtilities.isEventDispatchThread()) {
-		if(getState() == DownloadJob.RUNNING) {
-		    progress.mirrorComplete();
-		    previous_state = getState();
-		    setState(DownloadJob.COMPLETE);	    
-		}
-		mummy.deleteCurrentDownloadJob(this); // why wait for the cleanup which can't be interrupted anyway?
-	    }
-	    */
 	} else {
 	    System.err.println("@@@@ No process to interrupt");
@@ -807,22 +781,5 @@
 		mummy.deleteCurrentDownloadJob(this); 
 	    }
-	} /*else {
-	    // If we've got to here and the state isn't STOPPED then the
-	    // job is complete.
-	    System.err.println("**************** NOT Notifying download scrollpane");
-	    if(getState() == DownloadJob.RUNNING) {
-		progress.mirrorComplete();
-		previous_state = getState();
-		setState(DownloadJob.COMPLETE);	    
-	    }
-	}
-	
-	// Regardless of whether state==STOPPED or ends up being COMPLETE, the process is at an end now.
-	// Notify the DownloadScrollPane which is waiting on this job to complete that we are ready 
-	synchronized(this) {
-	    System.err.println("**************** Notifying download scrollpane");
-	    this.notify();
-	    }*/
-
+	}
     }
 
Index: main/trunk/gli/src/org/greenstone/gatherer/download/DownloadScrollPane.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/download/DownloadScrollPane.java	(revision 31720)
+++ main/trunk/gli/src/org/greenstone/gatherer/download/DownloadScrollPane.java	(revision 31721)
@@ -79,10 +79,10 @@
     }
 
-	/** 
-	 * To be used with DownloadJob.java's old_callDownload() and old_actionPerformed()
-	 * OR by uncommenting the "synchronized(this)" section in Download.java at the end of
-	 * its new callDownload() along with commenting out "mummy.deleteCurrentDownloadJob(this);"
-	 * in Download.java's doneCleanup().
-	*/
+    /** 
+     * To be used with DownloadJob.java's old_callDownload() and old_actionPerformed()
+     * OR by uncommenting the "synchronized(this)" section in Download.java at the end of
+     * its new callDownload() along with commenting out "mummy.deleteCurrentDownloadJob(this);"
+     * in Download.java's doneCleanup().
+     */
     public void old_deleteDownloadJob(DownloadJob delete_me) {
 	if (delete_me == job) {
@@ -107,8 +107,8 @@
     }
 
-	/**
-	 * If called to delete the current download job, this method won't do anything.
-	 * But if called on any inactive download job, its display is removed.
-	*/
+    /**
+     * If called to delete the current download job, this method won't do anything.
+     * But if called on any inactive download job, its display is removed.
+     */
     public void deleteDownloadJob(DownloadJob delete_me) {
 	if (delete_me != job) {
@@ -121,8 +121,8 @@
     }
 
-	/**
-	 * To be called when we're ready to delete the current download job,
-	 * else this method won't do anything
-	*/
+    /**
+     * To be called when we're ready to delete the current download job,
+     * else this method won't do anything
+     */
     public void deleteCurrentDownloadJob(DownloadJob delete_me) {
 	if (delete_me == job) {